#ifndef ACTION_STACK_H
#define ACTION_STACK_H

#include "Containers/CVector.h"
#include "Containers/CString.h"

#define CMD_STR           1
#define CMD_OBJ_FILE      2
#define CMD_SRC_FILE      3
#define CMD_COMPILED_OBJS 4
#define CMD_INCLUDE_DIRS  5
#define CMD_FILE_TITLE    6
#define CMD_LIBS          7

class Vars
{
  public:
    Vars(void);
    Vars(const CString &src, const CString &obj, const CString &incdirs, const CString &libs, const CString &title);
    
    CString ObjFile;     // Replaces %OBJ%
    CString Source;      // Replaces %SOURCE%
    CString IncludeDirs; // Replaces %INCLUDE DIRS%
    CString Libs;        // Replaces %COMPILED LIBS%
    CString Title;       // Replaces %BIN%
};

class Action
{
  public:
    Action(int cmd, char *str = 0);

    void Run(CString &str, const Vars &v);

    int Command;
    CString Str;
};

class ActionStack
{
  public:
    void Expand(const CString &str);
    void Run(const Vars &v);

    CVector<Action> Cmds;
};

#endif
