#ifndef COMPILER_H
#define COMPILER_H

#include "Containers/CVector.h"
#include "Containers/CString.h"

#include "ActionStack.h"

class Directory;
class ConfigFile;

class Compiler
{
  public:
    Compiler(const CString &name);

    void Expand(void);
    void Print(void);

    void BuildIncludeDirs(Directory *node);
    void AddAdditonalIncs(CVector<CString> &add);
    void Compile(const CString &objdir, Directory *node, ConfigFile *config);
    void Link(int depends_built = 0);
    int  CanLink(void);

    CString Name;
    int Default;
    int ShowCompFiles;
    int AutoDirTree;
    int NFilesBuilt;
    int Built;
    CString OutDir;

    CString FileTitle;
    CString ObjExt;
    CString CompileStr;
    CString LinkStr;
    CString IncludeDirSwitch;
    CString IncludeDirs;

    CVector<CString> Errors;
    CString ObjsToLink;
    CString LibsToLink;

    ActionStack CompileStack;
    ActionStack LinkStack;
};

#endif
