#include "CompilerDependency.h"

#include "Debug/Debug.h"

DependencyLink::DependencyLink(File *includedby, File *include)
{
  IncludedBy = includedby;
  Include    = include;
}

CompilerDependency::CompilerDependency(ConfigFile *config)
{
  Config = config;
}

void CompilerDependency::AddLink(File *includedby, File *include)
{
  unsigned int i;

  for(i = 0; i < Links.size(); ++i)
    if(Links[i].Include == include && Links[i].IncludedBy == includedby)
      return;

  Links.push_back(DependencyLink(includedby, include));
}

bool CompilerDependency::operator==(const ConfigFile *config) const
{
  return Config == config;
}
