#ifndef COMP_DEPENDENCY_H
#define COMP_DEPENDENCY_H

#include "Containers/CVector.h"
#include "Containers/CString.h"

class File;
class ConfigFile;

class DependencyLink
{
  public:
    DependencyLink(File *includeby, File *include);
    
    File *IncludedBy;
    File *Include;
};

class CompilerDependency
{
  public:
    CompilerDependency(ConfigFile *config);
    
    void AddLink(File *includeby, File *include);
    
    bool operator==(const ConfigFile *config) const;
    
    ConfigFile             *Config;
    CVector<DependencyLink> Links;
};

#endif
