#ifndef CONFIG_FILE_H
#define CONFIG_FILE_H

#include "Containers/CVector.h"
#include "Containers/CString.h"

#include "Database.h"
#include "Compiler.h"

#include "CompilerDependency.h"

class Directory;

class ConfigFile
{
  public:
    ConfigFile(const CString &file);

    void SetCompiler(const CString &comp);
    int  IsCompiler (const CString &comp);

    void GenerateDefaults(const char *file);
    void Read (const char *file);
    void Write(const char *file);

    void ValidateDirs(void);

    int  CheckDataBase(const CString &file, Directory *root);

    int  Compile(Directory *root);

    void BuildDirectLibList(void);
    int  BuildIndirectLibList(void);
    int  BuildIndirectLibList(const CVector<CompilerDependency> &list);

    int  AddAdditionalLib(const CString &lib);

    void AddDependency(File *includer, File *includie, ConfigFile *config);

    int Saved;

    CString F;

    CString ObjDir;
    CString LibDir;
    CString BinDir;
    CString LibFile;
    int MinRebuild;
    int IsLibrary;

    CVector<CString> AdditionalLibs;

    Compiler *Comp;

    CVector<Compiler> Comps;
    CVector<CString>  AdditonalIncludeDirs;

    CVector<CString>  HeaderTypes;
    CVector<CString>  SourceTypes;
    CVector<CString>  IgnoreDirs;
    CVector<CString>  IgnoreFiles;

    Database DBase;

    CVector<CompilerDependency> DependsOn;
};

#endif
