#ifndef DIRECTORY_H
#define DIRECTORY_H

#include "../Containers/CVector.h"
#include "../Containers/CString.h"

class DirList;
class DirectoryTree;
class ConfigFile;
class File;

class Directory
{
  public:
    Directory(const CString &path, DirectoryTree *root, ConfigFile *cfg = 0);
   ~Directory(void);

    void CheckTree(void);
    void CheckIncludes(void);

    void CheckForConfigFile(void);
    void SaveConfig(void);

    void GetSubDirectories(DirList &dir);
    
    void GetFiles(DirList &dir);
    
    void Clean(void);
    
    void GetSourceList(CVector<CString> &files);
    void GetModifiedList(CVector<CString> &files);

    CString Path;                 // Full Path
    ConfigFile *Config;

    CVector<Directory *> Dirs;    // List of the sub directories
    
    CVector<File *> Headers;
    CVector<File *> Sources;

    DirectoryTree *Tree;
};

#endif
