#ifndef DIRECTORY_TREE_H
#define DIRECTORY_TREE_H

#include "../Containers/CVector.h"
#include "../Containers/CString.h"

class Directory;
class ConfigFile;

class DirectoryTree
{
  public:
    DirectoryTree(void);
   ~DirectoryTree(void);

    void BuildTree(const CString &root);
    void BuildLibLists(void);
    void SaveConfigs(void);
    
    void Compile(void);
    void Clean(void);
    bool IsCompiler(const CString &comp) const;
    void SetCompiler(const CString &comp);
    
    CVector<CString> GetCompilerList(void);
    CVector<CString> GetActiveCompilers(void);
    CVector<CString> GetSourceList(void);
    CVector<CString> GetModifiedList(void);
    CVector<CString> GetDBBSList(void);
    CVector<CString> GetOutputList(void);
    
    void PrintDependencies(void);

    Directory  *Root;

    CVector<CString> HeaderTypes;
    CVector<CString> SourceTypes;
    CVector<CString> IgnoreDirs;
    CVector<CString> IgnoreFiles;
    
    CVector<ConfigFile *> Configs;
};

#endif
