#ifndef FILE_H
#define FILE_H

#include "../Containers/CVector.h"
#include "../Containers/CString.h"

#include <stdio.h>

class Parser;
class Directory;
class ConfigFile;

class File
{
  public:
    File(void);
    File(const CString &path, const CString &file, Directory *root, ConfigFile *config = 0);
   ~File(void);

    void CheckIncludes(int istemp = 0);

    void SetModified(void);
    File *FindFile(const CString &name);
    File *FindFile(Directory *node, const CString &dir, const CString &file);
    File *FindFile(Directory *node, const CString &file);
    CString GetRelativeLocation(const CString &name);

    int CheckAdditonalIncludesDirs(const CString &file);

    void GetTimeModifed(void);
    void GetChecksum(void);

    void Print(void);
    void Write(FILE *fp);
    int  Read (Parser &p);

    int  Modified(File &r);
    
    CString GetObjFile(void);
    int CompileRequired(void);

    bool operator==(const CString &r) const; // File == r
    bool operator==(const File &r) const;        // Checks Path and Name

    Directory *Root;  // Directory tree for searching for headers

    CString Name; // Name of the file
    CString Path; // Path to the file

    int LastModified; // Date/Time last modified
    int Checksum;     // Checksum generated from the file
    int WasModified;  // Has the file been modifed since the program ran?

    CVector<File *> IncludedBy; // List of files that include this file
    
    ConfigFile *Config;
};

#endif
