#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>

#include "../OS Specific/SystemCalls.h"
#include "../OS Specific/DirList.h"

#include "Management.h"

#include "../Debug/Debug.h"

void CheckDir(CString fldr)
{
  CString dir;    // Path to this folder
  CString folder; // Name of the current folder
  CString t;
  DirList dirlist;
  int i;

  for(i = fldr.length() - 2; i >= 0; --i)
    if(fldr[i] == '\\' || fldr[i] == '/')
      break;

  if(i >= 0)
  {
    folder = (fldr.c_str() + i + 1);
    folder[folder.length() - 1] = 0;
    fldr[i + 1] = 0;
    dir = fldr.c_str();
  }
  else
  {
    fldr[fldr.length() - 1] = 0;
    folder = fldr;
  }

  dirlist.OpenDir(dir.c_str());

  while((t = dirlist.GetNextDir()).length())
    if(t == folder.c_str()) // Intentional
      return;

  CreateDir((dir + folder).c_str());
}

void CheckDirRec(const CString &fldr)
{
  unsigned int i = 0;

  while((i = fldr.find_first_of("/\\", i)) != ~(unsigned int)0)
    CheckDir(fldr.substr(0, ++i));
}

int FileExists(const CString &file)
{
  FILE *fp = fopen(file.c_str(), "rb");
  if(fp)
  {
    fclose(fp);
    return 1;
  }
  return 0;
}
