#ifndef PARSER_CACHE_H
#define PARSER_CACHE_H

#include "../Containers/CVector.h"
#include "../FileIO/Parser.h"

class ParserCache
{
  public:
    ParserCache(void);
   ~ParserCache(void);
   
    void AddRef(void);
    ParserCache *RemoveRef(void);
    
    Parser *GetIncludeParser(void);
    void    ReleaseIncludeParser(void);
    Parser *GetChecksumParser(void);
    
    void BuildChecksumParser(void);
    Parser *BuildIncludeParser(void);
    
    CVector<Parser *> IncludeCache;
    Parser           *FileChecksum;
    
    unsigned int Refs;
    unsigned int InUse;
};

#endif
